Index: pjproject/branches/projects/uwp/aconfigure.ac
===================================================================
--- pjproject/branches/projects/uwp/aconfigure.ac	(revision 5512)
+++ pjproject/branches/projects/uwp/aconfigure.ac	(revision 5513)
@@ -1,3 +1,3 @@
-AC_INIT(pjproject,2.x)
+AC_INIT([pjproject],[2.x])
 
 host_orig="$host"
@@ -20,5 +20,4 @@
 		 pjsip/build/os-auto.mak
 		 third_party/build/os-auto.mak
-		 third_party/build/portaudio/os-auto.mak 
 		 ])
 
@@ -40,5 +39,5 @@
 AC_PROG_CC
 AC_PROG_CXX
-AC_LANG_C
+AC_LANG([C])
 
 AC_PROG_RANLIB
@@ -182,5 +181,5 @@
 dnl # --disable-floating-point option
 AC_ARG_ENABLE(floating-point,
-	      AC_HELP_STRING([--disable-floating-point],
+	      AS_HELP_STRING([--disable-floating-point],
 			     [Disable floating point where possible]),
 	      [if test "$enable_floating_point" = "no"; then
@@ -267,4 +266,7 @@
           	  #endif
           	 ])
+
+AC_CHECK_FUNC(localtime_r,[AC_DEFINE(PJ_HAS_LOCALTIME_R,1)])
+
 AC_MSG_RESULT([Setting PJ_OS_NAME to $target])
 AC_DEFINE_UNQUOTED(PJ_OS_NAME,["$target"])
@@ -342,4 +344,13 @@
 		    		   [socklen_t xxx = 0;])],
 		  [AC_DEFINE(PJ_HAS_SOCKLEN_T,1)
+		   AC_MSG_RESULT(yes)],
+		  AC_MSG_RESULT(no))
+
+dnl # Determine if IPV6_V6ONLY is available
+AC_MSG_CHECKING([if IPV6_V6ONLY is available])
+AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <sys/socket.h>
+                                     #include <netinet/in.h>]],
+		    		   [int opt = IPV6_V6ONLY;])],
+		  [AC_DEFINE(PJ_SOCK_HAS_IPV6_V6ONLY,1)
 		   AC_MSG_RESULT(yes)],
 		  AC_MSG_RESULT(no))
@@ -411,20 +422,24 @@
 dnl # 
 AC_SUBST(ac_os_objs)
+AC_SUBST(ac_linux_poll)
 AC_MSG_CHECKING([ioqueue backend])
 AC_ARG_ENABLE(epoll,
-	      AC_HELP_STRING([--enable-epoll],
+	      AS_HELP_STRING([--enable-epoll],
 			     [Use /dev/epoll ioqueue on Linux (experimental)]),
 	      [
 		ac_os_objs=ioqueue_epoll.o
 		AC_MSG_RESULT([/dev/epoll])
+		AC_DEFINE(PJ_HAS_LINUX_EPOLL,1)
+		ac_linux_poll=epoll
 	      ],
 	      [
 		ac_os_objs=ioqueue_select.o
-	        AC_MSG_RESULT([select()]) 
+		AC_MSG_RESULT([select()])
+		ac_linux_poll=select
 	      ])
 
 AC_SUBST(ac_shared_libraries)
 AC_ARG_ENABLE(shared,
-	      AC_HELP_STRING([--enable-shared],
+	      AS_HELP_STRING([--enable-shared],
 			     [Build shared libraries]),
 	      [if test "$enable_shared" = "yes"; then
@@ -451,10 +466,25 @@
 		;;
 	esac
+	# QoS
+	case $target in
+	  *darwin*)
+		;;
+	  *)
+		ac_os_objs="$ac_os_objs sock_qos_bsd.o"
+		;;
+	esac
 	# UUID
-	if test "$ac_has_uuid_lib" = "1" -a "$ac_has_uuid_h" = "1"; then
-		ac_os_objs="$ac_os_objs guid_uuid.o"
-	else
-		ac_os_objs="$ac_os_objs guid_simple.o"
-	fi
+	case $target in
+	  *android*)
+	  	ac_os_objs="$ac_os_objs guid_android.o"
+	  	;;
+	  *)
+		if test "$ac_has_uuid_lib" = "1" -a "$ac_has_uuid_h" = "1"; then
+			ac_os_objs="$ac_os_objs guid_uuid.o"
+		else
+			ac_os_objs="$ac_os_objs guid_simple.o"
+		fi
+		;;
+	esac
 	;;
 esac
@@ -462,5 +492,5 @@
 case $target in
   *darwin*)
-	ac_os_objs="$ac_os_objs os_core_darwin.o"
+	ac_os_objs="$ac_os_objs sock_qos_darwin.o os_core_darwin.o"
 	;;
 esac
@@ -474,5 +504,5 @@
 AC_SUBST(ac_external_speex,0)
 AC_ARG_WITH(external-speex,
-    AC_HELP_STRING([--with-external-speex],
+    AS_HELP_STRING([--with-external-speex],
 		   [Use external Speex development files, not the one in "third_party" directory. When this option is set, make sure that Speex is accessible to use (hint: use CFLAGS and LDFLAGS env var to set the include/lib paths)]),
     [
@@ -496,5 +526,5 @@
 AC_SUBST(ac_external_gsm,0)
 AC_ARG_WITH(external-gsm,
-    AC_HELP_STRING([--with-external-gsm],
+    AS_HELP_STRING([--with-external-gsm],
 		   [Use external GSM codec library, not the one in "third_party" directory. When this option is set, make sure that the GSM include/lib files are accessible to use (hint: use CFLAGS and LDFLAGS env var to set the include/lib paths)]),
     [
@@ -532,5 +562,5 @@
 AC_SUBST(ac_external_srtp,0)
 AC_ARG_WITH(external-srtp,
-    AC_HELP_STRING([--with-external-srtp],
+    AS_HELP_STRING([--with-external-srtp],
 		   [Use external SRTP development files, not the one in "third_party" directory. When this option is set, make sure that SRTP is accessible to use (hint: use CFLAGS and LDFLAGS env var to set the include/lib paths)]),
     [
@@ -559,8 +589,51 @@
 fi
 
+
+dnl # Use external libyuv installation
+AC_SUBST(ac_external_yuv,0)
+AC_ARG_WITH(external-yuv,
+    AS_HELP_STRING([--with-external-yuv],
+		   [Use external libyuv development files, not the one in "third_party" directory. When this option is set, make sure that libyuv is accessible to use (hint: use CFLAGS and LDFLAGS env var to set the include/lib paths)]),
+    [
+	if test "x$with_external_yuv" != "xno"; then
+		# Test libyuv installation
+		AC_MSG_CHECKING([if external libyuv devkit is installed])
+		AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <libyuv.h>]],
+						  [RGB24ToI420(0,0,0,0,0,0,0,0,0,0);])],
+				  [AC_MSG_RESULT(yes!!)
+				   ac_external_yuv="1"
+				   ],
+				  [AC_MSG_ERROR([Unable to use external libyuv. If libyuv development files are not available in the default locations, use CFLAGS and LDFLAGS env var to set the include/lib paths])])
+	fi
+    ]
+    )
+
+
+dnl # Use external webrtc installation
+AC_SUBST(ac_external_webrtc,0)
+AC_ARG_WITH(external-webrtc,
+    AS_HELP_STRING([--with-external-webrtc],
+		   [Use external webrtc development files, not the one in "third_party" directory. When this option is set, make sure that webrtc is accessible to use (hint: use CFLAGS and LDFLAGS env var to set the include/lib paths)]),
+    [
+	if test "x$with_external_webrtc" != "xno"; then
+		# Test webrtc installation
+		AC_MSG_CHECKING([if external webrtc devkit is installed])
+		AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <webrtc/modules/audio_processing/aec/aec_core.h>
+						     #include <webrtc/modules/audio_processing/aec/include/echo_cancellation.h>
+		]],
+						  [WebRtcAec_Create();])],
+				  [AC_MSG_RESULT(yes!!)
+				   ac_external_webrtc="1"
+				   ],
+				  [AC_MSG_ERROR([Unable to use external webrtc. If webrtc development files are not available in the default locations, use CFLAGS and LDFLAGS env var to set the include/lib paths])])
+	fi
+    ]
+    )
+
+
 dnl # Resample implementation
 AC_SUBST(ac_pjmedia_resample,libresample)
 AC_ARG_ENABLE(resample,
-	      AC_HELP_STRING([--disable-resample],
+	      AS_HELP_STRING([--disable-resample],
 			     [Disable resampling implementations]),
 	      [if test "$enable_resample" = "no"; then
@@ -573,5 +646,5 @@
 AC_SUBST(ac_pjmedia_snd)
 AC_ARG_ENABLE(sound,
-	      AC_HELP_STRING([--disable-sound],
+	      AS_HELP_STRING([--disable-sound],
 			     [Exclude sound (i.e. use null sound)]),
 	      [if test "$enable_sound" = "no"; then
@@ -584,5 +657,5 @@
 AC_SUBST(ac_external_pa,0)
 AC_ARG_WITH(external-pa,
-    AC_HELP_STRING([--with-external-pa],
+    AS_HELP_STRING([--with-external-pa],
 		   [Use external PortAudio development files, not the one in "third_party" directory. When this option is set, make sure that PortAudio is accessible to use (hint: use CFLAGS and LDFLAGS env var to set the include/lib paths)]),
     [
@@ -652,11 +725,9 @@
   *)
 	dnl # Check if ALSA is available
-	ac_pjmedia_snd=pa_unix
+	ac_pjmedia_snd=alsa
+	AC_SUBST(ac_pa_use_alsa,1)
 	AC_CHECK_HEADER(alsa/version.h,
-			[AC_SUBST(ac_pa_use_alsa,1)
-			 AC_SUBST(ac_pjmedia_snd,alsa)
-			 LIBS="$LIBS -lasound"
-			],
-		        [AC_SUBST(ac_pa_use_alsa,0)])
+			[LIBS="$LIBS -lasound"],
+		        [ac_pa_use_alsa=0])
 	AC_MSG_RESULT([Checking sound device backend... unix])
 
@@ -664,5 +735,5 @@
 	AC_SUBST(ac_pa_use_oss,1)
 	AC_ARG_ENABLE(oss,
-		      AC_HELP_STRING([--disable-oss],
+		      AS_HELP_STRING([--disable-oss],
 				     [Disable OSS audio (default: not disabled)]),
 		      [
@@ -678,7 +749,14 @@
 AC_SUBST(ac_pjmedia_video)
 
+# Disable video on mingw
+case $target in
+ *mingw*)
+	enable_video="no"
+	;;
+esac
+
 dnl # --disable-video option
 AC_ARG_ENABLE(video,
-	      AC_HELP_STRING([--disable-video],
+	      AS_HELP_STRING([--disable-video],
 	      		     [Disable video feature]),
 	      [if test "$enable_video" = "no"; then
@@ -726,41 +804,56 @@
 	ac_android_cflags="$ac_android_cflags -DPJMEDIA_VIDEO_DEV_HAS_ANDROID=1"
 	;;
-  *-apple-darwin_ios*)
-	ac_pjmedia_video=iphone_os
-	AC_SUBST(ac_pjmedia_video_has_ios)
-	AC_SUBST(ac_ios_cflags)
+  *darwin*)
+	ac_pjmedia_video=darwin_os
+	AC_SUBST(ac_pjmedia_video_has_darwin)
+	AC_SUBST(ac_pjmedia_video_has_ios_opengl)
+	AC_SUBST(ac_darwin_cflags)
 	SAVED_LIBS="$LIBS"
 	LIBS="-framework AVFoundation -framework CoreGraphics -framework QuartzCore -framework CoreVideo -framework CoreMedia"
-	AC_LINK_IFELSE([AC_LANG_PROGRAM([[]], [])],[ac_pjmedia_video_has_ios=yes],[ac_pjmedia_video_has_ios=no])
+	AC_LINK_IFELSE([AC_LANG_PROGRAM([[]], [])],
+		       [ac_pjmedia_video_has_darwin=yes],
+		       [ac_pjmedia_video_has_darwin=no])
+	LIBS="-framework OpenGLES"
+	AC_LINK_IFELSE([AC_LANG_PROGRAM([[]], [])],
+		       [ac_pjmedia_video_has_ios_opengl=yes],
+		       [ac_pjmedia_video_has_ios_opengl=no])
 	LIBS="$SAVED_LIBS"
-	if test "$ac_pjmedia_video_has_ios" = "yes"; then
-	  ac_ios_cflags="-DPJMEDIA_VIDEO_DEV_HAS_IOS=1 -DPJMEDIA_VIDEO_DEV_HAS_IOS_OPENGL=1"
-	  LIBS="$LIBS -framework OpenGLES -framework AVFoundation -framework CoreGraphics -framework QuartzCore -framework CoreVideo -framework CoreMedia"
+	if test "$ac_pjmedia_video_has_darwin" = "yes"; then
+	  ac_darwin_cflags="-DPJMEDIA_VIDEO_DEV_HAS_DARWIN=1"
+	  LIBS="$LIBS -framework AVFoundation -framework CoreGraphics -framework QuartzCore -framework CoreVideo -framework CoreMedia"
 	  AC_MSG_RESULT([Checking if AVFoundation framework is available... yes])
 	else
 	  AC_MSG_RESULT([Checking if AVFoundation framework is available... no])
 	fi
-	;;
-  *darwin*)
-	ac_pjmedia_video=mac_os
-	AC_SUBST(ac_pjmedia_video_has_qt)
-	AC_SUBST(ac_qt_cflags)
-	SAVED_LIBS="$LIBS"
-	LIBS="-framework QTKit"
-	AC_LINK_IFELSE([AC_LANG_PROGRAM([[]], [])],[ac_pjmedia_video_has_qt=yes],[ac_pjmedia_video_has_qt=no])
-	LIBS="$SAVED_LIBS"
-	if test "$ac_pjmedia_video_has_qt" = "yes"; then
-	  ac_qt_cflags="-DPJMEDIA_VIDEO_DEV_HAS_QT=1"
-	  LIBS="$LIBS -framework QTKit -framework QuartzCore -framework OpenGL"
-	  AC_MSG_RESULT([Checking if QTKit framework is available... yes])
+	if test "$ac_pjmedia_video_has_ios_opengl" = "yes"; then
+	  ac_darwin_cflags+=" -DPJMEDIA_VIDEO_DEV_HAS_IOS_OPENGL=1"
+	  LIBS="$LIBS -framework OpenGLES"
+	  AC_MSG_RESULT([Checking if OpenGLES framework is available... yes])
 	else
-	  AC_MSG_RESULT([Checking if QTKit framework is available... no])
+	  AC_MSG_RESULT([Checking if OpenGLES framework is available... no])
 	fi
-	;;
+        if false; then
+          # QTKit is deprecated, see ticket #1931.
+	  ac_pjmedia_video=mac_os
+	  AC_SUBST(ac_pjmedia_video_has_qt)
+	  AC_SUBST(ac_qt_cflags)
+	  SAVED_LIBS="$LIBS"
+	  LIBS="-framework QTKit"
+	  AC_LINK_IFELSE([AC_LANG_PROGRAM([[]], [])],[ac_pjmedia_video_has_qt=yes],[ac_pjmedia_video_has_qt=no])
+	  LIBS="$SAVED_LIBS"
+	  if test "$ac_pjmedia_video_has_qt" = "yes"; then
+	    ac_qt_cflags="-DPJMEDIA_VIDEO_DEV_HAS_QT=1"
+	    LIBS="$LIBS -framework QTKit -framework QuartzCore -framework OpenGL"
+	    AC_MSG_RESULT([Checking if QTKit framework is available... yes])
+	  else
+	    AC_MSG_RESULT([Checking if QTKit framework is available... no])
+ 	  fi
+ 	fi
+ 	;;
  esac
 fi
 
 AC_ARG_ENABLE(ext_sound,
-	      AC_HELP_STRING([--enable-ext-sound],
+	      AS_HELP_STRING([--enable-ext-sound],
 			     [PJMEDIA will not provide any sound device backend]),
 	      [if test "$enable_ext_sound" = "yes"; then
@@ -773,5 +866,5 @@
 AC_SUBST(ac_no_small_filter)
 AC_ARG_ENABLE(small-filter,
-	      AC_HELP_STRING([--disable-small-filter],
+	      AS_HELP_STRING([--disable-small-filter],
 			     [Exclude small filter in resampling]),
 	      [if test "$enable_small_filter" = "no"; then
@@ -784,5 +877,5 @@
 AC_SUBST(ac_no_large_filter)
 AC_ARG_ENABLE(large-filter,
-	      AC_HELP_STRING([--disable-large-filter],
+	      AS_HELP_STRING([--disable-large-filter],
 			     [Exclude large filter in resampling]),
 	      [if test "$enable_large_filter" = "no"; then
@@ -795,5 +888,5 @@
 AC_SUBST(ac_no_speex_aec)
 AC_ARG_ENABLE(speex-aec,
-	      AC_HELP_STRING([--disable-speex-aec],
+	      AS_HELP_STRING([--disable-speex-aec],
 			     [Exclude Speex Acoustic Echo Canceller/AEC]),
 	      [if test "$enable_speex_aec" = "no"; then
@@ -806,5 +899,5 @@
 AC_SUBST(ac_no_g711_codec)
 AC_ARG_ENABLE(g711-codec,
-	      AC_HELP_STRING([--disable-g711-codec],
+	      AS_HELP_STRING([--disable-g711-codec],
 			     [Exclude G.711 codecs from the build]),
 	      [if test "$enable_g711_codec" = "no"; then
@@ -819,5 +912,5 @@
 AC_SUBST(ac_no_l16_codec)
 AC_ARG_ENABLE(l16-codec,
-	      AC_HELP_STRING([--disable-l16-codec],
+	      AS_HELP_STRING([--disable-l16-codec],
 			     [Exclude Linear/L16 codec family from the build]),
 	      [if test "$enable_l16_codec" = "no"; then
@@ -832,5 +925,5 @@
 AC_SUBST(ac_no_gsm_codec)
 AC_ARG_ENABLE(gsm-codec,
-	      AC_HELP_STRING([--disable-gsm-codec],
+	      AS_HELP_STRING([--disable-gsm-codec],
 			     [Exclude GSM codec in the build]),
 	      [if test "$enable_gsm_codec" = "no"; then
@@ -844,5 +937,5 @@
 AC_SUBST(ac_no_g722_codec)
 AC_ARG_ENABLE(g722-codec,
-	      AC_HELP_STRING([--disable-g722-codec],
+	      AS_HELP_STRING([--disable-g722-codec],
 			     [Exclude G.722 codec in the build]),
 	      [if test "$enable_g722_codec" = "no"; then
@@ -856,5 +949,5 @@
 AC_SUBST(ac_no_g7221_codec)
 AC_ARG_ENABLE(g7221-codec,
-	      AC_HELP_STRING([--disable-g7221-codec],
+	      AS_HELP_STRING([--disable-g7221-codec],
 			     [Exclude G.7221 codec in the build]),
 	      [if test "$enable_g7221_codec" = "no"; then
@@ -868,5 +961,5 @@
 AC_SUBST(ac_no_speex_codec)
 AC_ARG_ENABLE(speex-codec,
-	      AC_HELP_STRING([--disable-speex-codec],
+	      AS_HELP_STRING([--disable-speex-codec],
 			     [Exclude Speex codecs in the build]),
 	      [if test "$enable_speex_codec" = "no"; then
@@ -880,5 +973,5 @@
 AC_SUBST(ac_no_ilbc_codec)
 AC_ARG_ENABLE(ilbc-codec,
-	      AC_HELP_STRING([--disable-ilbc-codec],
+	      AS_HELP_STRING([--disable-ilbc-codec],
 			     [Exclude iLBC codec in the build]),
 	      [if test "$enable_ilbc_codec" = "no"; then
@@ -891,5 +984,5 @@
 dnl # Include libsamplerate
 AC_ARG_ENABLE(libsamplerate,
-           AC_HELP_STRING([--enable-libsamplerate],
+           AS_HELP_STRING([--enable-libsamplerate],
                     [Link with libsamplerate when available.]),
            [
@@ -905,5 +998,5 @@
 AC_SUBST(ac_resample_dll)
 AC_ARG_ENABLE(resample_dll,
-	      AC_HELP_STRING([--enable-resample-dll],
+	      AS_HELP_STRING([--enable-resample-dll],
 			     [Build libresample as shared library]),
 	      [if test "$enable_resample_dll" = "yes"; then
@@ -916,5 +1009,5 @@
 dnl # SDL alt prefix
 AC_ARG_WITH(sdl,
-    AC_HELP_STRING([--with-sdl=DIR],
+    AS_HELP_STRING([--with-sdl=DIR],
 		   [Specify alternate libSDL prefix]),
     [],
@@ -929,5 +1022,5 @@
 dnl # SDL
 AC_ARG_ENABLE(sdl,
-	      AC_HELP_STRING([--disable-sdl],
+	      AS_HELP_STRING([--disable-sdl],
 			     [Disable SDL (default: not disabled)]),
 	      [
@@ -961,5 +1054,5 @@
 
 AC_ARG_WITH(ffmpeg,
-    AC_HELP_STRING([--with-ffmpeg=DIR],
+    AS_HELP_STRING([--with-ffmpeg=DIR],
 		   [Specify alternate FFMPEG prefix]),
     [],
@@ -974,5 +1067,5 @@
 dnl # FFMPEG stuffs
 AC_ARG_ENABLE(ffmpeg,
-	      AC_HELP_STRING([--disable-ffmpeg],
+	      AS_HELP_STRING([--disable-ffmpeg],
 			     [Disable ffmpeg (default: not disabled)]),
 	      [
@@ -1000,7 +1093,7 @@
 			AC_MSG_CHECKING([ffmpeg packages])
 			av_pkg=""
-			if $PKG_CONFIG --exists libdevice; then
+			if $PKG_CONFIG --exists libavdevice; then
 				ac_ffmpeg_cflags="$ac_ffmpeg_cflags -DPJMEDIA_HAS_LIBAVDEVICE=1"
-				av_pkg="$av_pkg libdevice"
+				av_pkg="$av_pkg libavdevice"
 			fi
 			if $PKG_CONFIG --exists libavformat; then
@@ -1019,8 +1112,4 @@
 				ac_ffmpeg_cflags="$ac_ffmpeg_cflags -DPJMEDIA_HAS_LIBAVUTIL=1"
 				av_pkg="$av_pkg libavutil"
-			fi
-			if $PKG_CONFIG --exists libavcore; then
-				ac_ffmpeg_cflags="$ac_ffmpeg_cflags -DPJMEDIA_HAS_LIBAVCORE=1"
-				av_pkg="$av_pkg libavcore"
 			fi
 			
@@ -1090,4 +1179,10 @@
 		fi
 		
+		AC_CHECK_TYPES(enum AVPixelFormat,
+			       [],
+			       [ac_ffmpeg_cflags="$ac_ffmpeg_cflags -DPJMEDIA_USE_OLD_FFMPEG=1"],
+			       [[#include <libavformat/avformat.h>]]
+			     )
+				     
 		LIBS="$LIBS $ac_ffmpeg_ldflags"
 		export PKG_CONFIG_PATH=$SAVED_PKG_CONFIG_PATH
@@ -1097,5 +1192,5 @@
 dnl # Video for Linux 2
 AC_ARG_ENABLE(v4l2,
-	      AC_HELP_STRING([--disable-v4l2],
+	      AS_HELP_STRING([--disable-v4l2],
 			     [Disable Video4Linux2 (default: not disabled)]),
 	      [
@@ -1118,5 +1213,5 @@
 dnl # OpenH264 alt prefix
 AC_ARG_WITH(openh264,
-            AC_HELP_STRING([--with-openh264=DIR],
+            AS_HELP_STRING([--with-openh264=DIR],
 		           [Specify alternate OpenH264 prefix]),
             [],
@@ -1133,5 +1228,5 @@
 AC_SUBST(ac_openh264_ldflags)
 AC_ARG_ENABLE(openh264,
-	      AC_HELP_STRING([--disable-openh264],
+	      AS_HELP_STRING([--disable-openh264],
 			     [Disable OpenH264 (default: not disabled)]),
 	      [
@@ -1181,156 +1276,4 @@
 	      ])
 
-dnl # libyuv alt prefix
-AC_ARG_WITH(libyuv,
-            AC_HELP_STRING([--with-libyuv=DIR],
-		           [Specify alternate libyuv prefix]),
-            [],
-            [with_libyuv=no]
-            )
-
-dnl # Do not use default libyuv installation if we are cross-compiling
-if test "x$ac_cross_compile" != "x" -a "x$with_libyuv" = "xno"; then
-    enable_libyuv=no
-fi	      
-	      
-dnl # Include libyuv
-AC_SUBST(ac_libyuv_cflags)
-AC_SUBST(ac_libyuv_ldflags)
-AC_ARG_ENABLE(libyuv,
-	      AC_HELP_STRING([--disable-libyuv],
-			     [Exclude libyuv in the build]),
-	      [if test "$enable_libyuv" = "no"; then
-		AC_MSG_RESULT([Checking if libyuv is disabled...yes])
-	       fi],
-	      [
-		  if test "x$with_libyuv" != "xno" -a "x$with_libyuv" != "x"; then
-		        LIBYUV_PREFIX=$with_libyuv
-		  	LIBYUV_CFLAGS="-I$LIBYUV_PREFIX/include"
-		  	
-			case $target in
-			    *-apple-darwin_ios*)
-				LIBYUV_LDFLAGS="-L$LIBYUV_PREFIX/out_ios/Release-iphoneos"
-				case $ARCH in
-				    *arm*)
-				    LIBYUV_LIBS="-lyuv_neon"
-				    ;;
-				*)
-				    ;;
-				esac
-				;;			
-			    *mingw* | *cygw* | *win32* | *w32* | *darwin* | *linux* | *android*)
-				LIBYUV_LDFLAGS="-L$LIBYUV_PREFIX/out/Release"
-				;;
-			    *)
-				LIBYUV_CFLAGS=""
-				LIBYUV_LDFLAGS=""
-				;;
-			esac		  	
-		  	
-			AC_MSG_RESULT([Using libyuv prefix... $with_libyuv])
-		  else
-		  	LIBYUV_CFLAGS=""
-			LIBYUV_LDFLAGS="" 
-		  fi
-		  		  
-		  LIBYUV_LIBS="$LIBYUV_LIBS -lyuv"
-		  
-		  SAVED_LIBS="$LIBS"
-		  SAVED_LDFLAGS="$LDFLAGS"
-		  SAVED_CFLAGS="$CFLAGS"
-		  
-		  LIBS="$LIBYUV_LIBS $LIBS"
-		  LDFLAGS="$LIBYUV_LDFLAGS $LDFLAGS"
-		  CFLAGS="$LIBYUV_CFLAGS $CFLAGS"
-		  
-		  AC_CHECK_LIB(yuv,
-			       I420Scale,
-			       [ ac_libyuv_cflags="-DPJMEDIA_HAS_LIBYUV=1 $LIBYUV_CFLAGS"
-		  		 ac_libyuv_ldflags="$LIBYUV_LDFLAGS $LIBYUV_LIBS"
-			       ],
-			       [ LIBS="$SAVED_LIBS"
-				 LDFLAGS="$SAVED_LDFLAGS"
-				 CFLAGS="$SAVED_CFLAGS"
-			       ],
-			       []
-			       )
-	      ])
-
-
-dnl # WebRtc alt prefix
-AC_ARG_WITH(webrtc,
-            AC_HELP_STRING([--with-webrtc=DIR],
-		           [Specify alternate WebRtc prefix]),
-            [],
-            [with_webrtc=no]
-            )
-
-dnl # Do not use default webrtc installation if we are cross-compiling
-if test "x$ac_cross_compile" != "x" -a "x$with_webrtc" = "xno"; then
-    enable_webrtc=no
-fi	      
-	      
-dnl # WebRtc
-AC_SUBST(ac_webrtc_cflags)
-AC_SUBST(ac_webrtc_ldflags)
-AC_ARG_ENABLE(webrtc,
-	      AC_HELP_STRING([--disable-webrtc],
-			     [Exclude webrtc in the build]),
-	      [if test "$enable_webrtc" = "no"; then
-		AC_MSG_RESULT([Checking if webrtc is disabled...yes])
-	       fi],
-	      [
-		  if test "x$with_webrtc" != "xno" -a "x$with_webrtc" != "x"; then
-		        WEBRTC_PREFIX=$with_webrtc
-		  	WEBRTC_CFLAGS="-I$WEBRTC_PREFIX/src"
-		  	
-			case $target in
-			    *-apple-darwin_ios*)
-				case $ARCH in
-				    *arm*)
-				    WEBRTC_CFLAGS="-DPJMEDIA_WEBRTC_AEC_USE_MOBILE=1 $WEBRTC_CFLAGS"
-				    WEBRTC_LDFLAGS="-L$WEBRTC_PREFIX/src/out_ios/Release-iphoneos"
-				    WEBRTC_LIBS="-laudio_processing_neon -lcommon_audio_neon"
-				    ;;
-				*)
-				    ;;
-				esac
-				;;			
-			    *mingw* | *cygw* | *win32* | *w32* | *darwin* | *linux* | *android*)
-			        WEBRTC_LDFLAGS="-L$WEBRTC_PREFIX/src/out/Release"
-			        WEBRTC_LIBS="-laudio_processing_sse2" 
-				;;
-			    *)
-				;;
-			esac		  	
-		  	
-			AC_MSG_RESULT([Using webrtc prefix... $with_webrtc])
-		  else
-		  	WEBRTC_CFLAGS=""
-			WEBRTC_LDFLAGS="" 
-		  fi
-		  		  
-		  WEBRTC_LIBS="$WEBRTC_LIBS -laudio_processing -lcommon_audio -lsystem_wrappers"
-		  
-		  SAVED_LIBS="$LIBS"
-		  SAVED_LDFLAGS="$LDFLAGS"
-		  SAVED_CFLAGS="$CFLAGS"
-		  
-		  LIBS="$WEBRTC_LIBS $LIBS"
-		  LDFLAGS="$WEBRTC_LDFLAGS $LDFLAGS"
-		  CFLAGS="$WEBRTC_CFLAGS $CFLAGS"
-		  
-		  AC_CHECK_LIB(audio_processing,
-			       WebRtcAec_Process,
-			       [ ac_webrtc_cflags="-DPJMEDIA_HAS_WEBRTC_AEC=1 $WEBRTC_CFLAGS"
-		  		 ac_webrtc_ldflags="$WEBRTC_LDFLAGS $WEBRTC_LIBS"
-			       ],
-			       [ LIBS="$SAVED_LIBS"
-				 LDFLAGS="$SAVED_LDFLAGS"
-				 CFLAGS="$SAVED_CFLAGS"
-			       ],
-			       []
-			       )
-	      ])
 
 dnl ########################################################
@@ -1338,5 +1281,5 @@
 dnl #
 AC_ARG_ENABLE(ipp,
-    AC_HELP_STRING([--enable-ipp],
+    AS_HELP_STRING([--enable-ipp],
 		   [Enable Intel IPP support. Specify the Intel IPP package and samples location using IPPROOT and IPPSAMPLES env var or with --with-ipp and --with-ipp-samples options]),
     [],
@@ -1345,5 +1288,5 @@
 
 AC_ARG_WITH(ipp,
-    AC_HELP_STRING([--with-ipp=DIR],
+    AS_HELP_STRING([--with-ipp=DIR],
 		   [Specify the Intel IPP location]),
     [],
@@ -1352,5 +1295,5 @@
 
 AC_ARG_WITH(ipp-samples,
-    AC_HELP_STRING([--with-ipp-samples=DIR],
+    AS_HELP_STRING([--with-ipp-samples=DIR],
 		   [Specify the Intel IPP samples location]),
     [],
@@ -1359,5 +1302,5 @@
 
 AC_ARG_WITH(ipp-arch,
-    AC_HELP_STRING([--with-ipp-arch=ARCH],
+    AS_HELP_STRING([--with-ipp-arch=ARCH],
 		   [Specify the Intel IPP ARCH suffix, e.g. "64" or "em64t. Default is blank for IA32"]),
     [],
@@ -1577,5 +1520,5 @@
 dnl # SSL alt prefix
 AC_ARG_WITH(ssl,
-    AC_HELP_STRING([--with-ssl=DIR],
+    AS_HELP_STRING([--with-ssl=DIR],
 		   [Specify alternate libssl prefix]),
     [],
@@ -1590,6 +1533,9 @@
 dnl # Include SSL support
 AC_SUBST(ac_no_ssl)
+AC_SUBST(ac_ssl_has_aes_gcm,0)
+AC_SUBST(ac_ssl_has_ec,0)
+AC_SUBST(ac_ssl_has_sigalg,0)
 AC_ARG_ENABLE(ssl,
-	      AC_HELP_STRING([--disable-ssl],
+	      AS_HELP_STRING([--disable-ssl],
 			     [Exclude SSL support the build (default: autodetect)])
 	      ,
@@ -1615,4 +1561,51 @@
 		if test "x$openssl_h_present" = "x1" -a "x$libssl_present" = "x1" -a "x$libcrypto_present" = "x1"; then
 	        	AC_MSG_RESULT([OpenSSL library found, SSL support enabled])
+			
+			# Check if SRTP should be compiled with OpenSSL
+			# support, to enable cryptos such as AES GCM
+			AC_CHECK_LIB(crypto,EVP_aes_128_gcm,[ac_ssl_has_aes_gcm=1])
+			if test "x$ac_ssl_has_aes_gcm" = "x1"; then
+				AC_MSG_RESULT([OpenSSL has AES GCM support, SRTP will use OpenSSL])
+			else
+				AC_MSG_RESULT([OpenSSL AES GCM support not found, SRTP will only support AES CM cryptos])
+			fi
+
+			# Check if OpenSSL supports setting curve algorithm
+			# and has elliptic curve
+			
+			AC_MSG_CHECKING([OpenSSL setting curve functions])
+			AC_SUBST(set_curve_present,0)
+			AC_SUBST(ec_curve_present,0)
+			AC_LINK_IFELSE([AC_LANG_PROGRAM([[#include <openssl/ssl.h>
+					          ]],
+					          [ SSL_set1_curves(NULL, NULL, 0);]
+					         )],
+		  		 [ set_curve_present=1
+		  		   AC_MSG_RESULT(ok)
+		  		  ],
+		  		 [
+		  		   AC_MSG_RESULT(no)
+		  		 ])
+
+			AC_CHECK_LIB(ssl,EC_curve_nid2nist,[ec_curve_present=1])
+			if test "x$set_curve_present" = "x1" -a "x$ec_curve_present" = "x1"; then
+				[ac_ssl_has_ec=1]
+				AC_MSG_RESULT([OpenSSL has elliptic curve support])
+			else
+				AC_MSG_RESULT([OpenSSL elliptic curve algorithm unsupported])
+			fi
+
+			AC_MSG_CHECKING([OpenSSL setting sigalg])
+			AC_LINK_IFELSE([AC_LANG_PROGRAM([[#include <openssl/ssl.h>
+					          ]],
+					          [SSL_set1_sigalgs_list(NULL, NULL);]
+					         )],
+		  		 [ ac_ssl_has_sigalg=1
+		  		   AC_MSG_RESULT(ok)
+		  		  ],
+		  		 [
+		  		   AC_MSG_RESULT(no)
+		  		 ])
+
 			# PJSIP_HAS_TLS_TRANSPORT setting follows PJ_HAS_SSL_SOCK
 			#AC_DEFINE(PJSIP_HAS_TLS_TRANSPORT, 1)
@@ -1625,13 +1618,13 @@
 dnl # Obsolete option --with-opencore-amrnb
 AC_ARG_WITH(opencore-amrnb,
-    AC_HELP_STRING([--with-opencore-amrnb=DIR],
+    AS_HELP_STRING([--with-opencore-amrnb=DIR],
 		   [This option is obsolete and replaced by --with-opencore-amr=DIR]),
     [AC_MSG_ERROR(This option is obsolete and replaced by --with-opencore-amr=DIR)],
-    []
+    [true;]
     )
 
 dnl # opencore-amr alt prefix
 AC_ARG_WITH(opencore-amr,
-    AC_HELP_STRING([--with-opencore-amr=DIR],
+    AS_HELP_STRING([--with-opencore-amr=DIR],
 		   [Specify alternate libopencore-amr prefix]),
     [],
@@ -1646,5 +1639,5 @@
 dnl # vo-amrwbenc alt prefix
 AC_ARG_WITH(opencore-amrwbenc,
-    AC_HELP_STRING([--with-opencore-amrwbenc=DIR],
+    AS_HELP_STRING([--with-opencore-amrwbenc=DIR],
 		   [Specify alternate libvo-amrwbenc prefix]),
     [],
@@ -1662,5 +1655,5 @@
 AC_SUBST(ac_no_opencore_amrwb)
 AC_ARG_ENABLE(opencore_amr,
-	      AC_HELP_STRING([--disable-opencore-amr],
+	      AS_HELP_STRING([--disable-opencore-amr],
 			     [Exclude OpenCORE AMR support from the build (default: autodetect)])
 	      ,
@@ -1717,5 +1710,5 @@
 dnl # SILK prefix
 AC_ARG_WITH(silk,
-    AC_HELP_STRING([--with-silk=DIR],
+    AS_HELP_STRING([--with-silk=DIR],
 		   [Specify alternate SILK prefix]),
     [],
@@ -1731,5 +1724,5 @@
 AC_SUBST(ac_no_silk)
 AC_ARG_ENABLE(silk,
-	      AC_HELP_STRING([--disable-silk],
+	      AS_HELP_STRING([--disable-silk],
 			     [Exclude SILK support from the build (default: autodetect)])
 	      ,
@@ -1762,4 +1755,128 @@
 	      ])
 
+dnl # Do not use default OPUS installation if we are cross-compiling
+if test "x$ac_cross_compile" != "x" -a "x$with_opus" = "xno"; then
+    enable_opus=no
+fi
+
+dnl # OPUS prefix
+AC_ARG_WITH(opus,
+    AS_HELP_STRING([--with-opus=DIR],
+		   [Specify alternate OPUS prefix]),
+    [],
+    [with_opus=no]
+    )
+
+dnl # Include OPUS support
+AC_SUBST(ac_no_opus)
+AC_ARG_ENABLE(opus,
+	      AS_HELP_STRING([--disable-opus],
+			     [Exclude OPUS support from the build (default: autodetect)])
+	      ,
+	      [
+		if test "$enable_opus" = "no"; then
+		 [ac_no_opus=1]
+		 AC_DEFINE(PJMEDIA_HAS_OPUS_CODEC,0)
+		 AC_MSG_RESULT([Checking if OPUS support is disabled... yes])
+	        fi
+	      ],
+	      [
+		AC_MSG_RESULT([checking for OPUS installations..])
+                if test "x$with_opus" != "xno" -a "x$with_opus" != "x"; then
+                    CFLAGS="$CFLAGS -I$with_opus/include"
+		    CPPFLAGS="$CPPFLAGS -I$with_opus/include"
+                    LDFLAGS="$LDFLAGS -L$with_opus/lib"
+                    AC_MSG_RESULT([Using OPUS prefix... $with_opus])
+                fi
+		AC_SUBST(opus_h_present)
+		AC_SUBST(opus_present)
+		AC_CHECK_HEADER(opus/opus.h,[opus_h_present=1])
+		AC_CHECK_LIB(opus,opus_repacketizer_get_size,[opus_present=1 && LIBS="-lopus $LIBS"])
+		if test "x$opus_h_present" = "x1" -a "x$opus_present" = "x1"; then
+	        	AC_MSG_RESULT([OPUS library found, OPUS support enabled])
+	        	AC_DEFINE(PJMEDIA_HAS_OPUS_CODEC,1)
+		else
+			[ac_no_opus=1]
+	        	AC_MSG_RESULT([OPUS library not found, OPUS support disabled])
+			AC_DEFINE(PJMEDIA_HAS_OPUS_CODEC,0)
+		fi
+	      ])
+
+dnl # Include libyuv
+AC_SUBST(ac_no_yuv)
+AC_ARG_ENABLE(libyuv,
+	      AS_HELP_STRING([--disable-libyuv],
+			     [Exclude libyuv in the build]),
+	      [if test "$enable_libyuv" = "no"; then
+		[ac_no_yuv=1]
+		AC_DEFINE(PJMEDIA_HAS_LIBYUV,0)
+		AC_MSG_RESULT([Checking if libyuv is disabled...yes])
+	       fi],
+	      AC_MSG_RESULT([Checking if libyuv is disabled...no]))
+
+
+dnl # Include webrtc
+AC_SUBST(ac_no_webrtc)
+AC_SUBST(ac_webrtc_instset)
+AC_SUBST(ac_webrtc_cflags)
+AC_SUBST(ac_webrtc_ldflags)
+AC_ARG_ENABLE(libwebrtc,
+	      AS_HELP_STRING([--disable-libwebrtc],
+			     [Exclude libwebrtc in the build]),
+	      [if test "$enable_libwebrtc" = "no"; then
+		[ac_no_webrtc=1]
+		AC_DEFINE(PJMEDIA_HAS_LIBWEBRTC,0)
+		AC_MSG_RESULT([Checking if libwebrtc is disabled...yes])
+	       fi],
+	      [
+		  AC_MSG_RESULT([Checking if libwebrtc is disabled...no])
+		  case $target in
+		      *-apple-darwin_ios*)
+			case $target in
+			    arm64*)
+				ac_webrtc_instset=neon
+				ac_webrtc_cflags="-DWEBRTC_ARCH_ARM64"
+			    	;;
+			    *arm*)
+				ac_webrtc_instset=neon
+			    	;;
+			    *)
+				ac_webrtc_instset=sse2
+			    	;;
+			esac
+		        ;;
+		      *android*)
+			case $TARGET_ABI in
+			    armeabi-v7a)
+				ac_webrtc_instset=neon
+				ac_webrtc_cflags="-mfloat-abi=softfp -mfpu=neon"
+			    	;;
+			    armeabi)
+				ac_webrtc_instset=neon
+				ac_webrtc_cflags="-mthumb -mfloat-abi=softfp -mfpu=neon -march=armv7"
+			    	;;
+			    arm64*)
+				ac_webrtc_instset=neon
+				ac_webrtc_cflags="-DWEBRTC_ARCH_ARM64"
+			    	;;
+			    mips64*)
+			    	ac_webrtc_instset=generic
+			        ;;
+			    mips*)
+			    	ac_webrtc_instset=mips
+			        ;;
+			    *)
+				ac_webrtc_instset=sse2
+			    	;;
+			esac
+		        ;;
+		     *mingw* | *cygw* | *win32* | *w32* | *darwin* | *linux*)
+			ac_webrtc_instset=sse2
+			;;
+		     *)
+			;;
+		esac	
+	      ])
+
 
 dnl ##########################################
@@ -1832,5 +1949,4 @@
 
 AC_SUBST(target)
-AC_SUBST(ac_linux_poll,select)
 AC_SUBST(ac_host,unix)
 AC_SUBST(ac_main_obj)
@@ -1846,5 +1962,5 @@
 
 ac_build_mak_vars=`echo $ac_build_mak_vars | sed 's/\\\\n/\n/g'`
-AC_OUTPUT()
+AC_OUTPUT
 
 
